Bug 519480 - 64-bit strace is lazy on execve of 32-bit process
64-bit strace is lazy on execve of 32-bit process
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: strace (Show other bugs)
rawhide
x86_64 Linux
low Severity medium
: ---
: ---
Assigned To: Roland McGrath
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-08-26 15:02 EDT by John Reiser
Modified: 2009-11-12 21:34 EST (History)
4 users (show)

See Also:
Fixed In Version: 4.5.19-1.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-12 21:33:24 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description John Reiser 2009-08-26 15:02:57 EDT
Description of problem: When run on (64-bit) x86_64, then strace for execve() of a (32-bit) i686 process prints just the address when an argv string or environment variable resides above 0xfffffffffff00000.  This happens even in -v mode (verbose), and makes strace much less useful.


Version-Release number of selected component (if applicable):
strace-4.5.18-3.fc12.x86_64


How reproducible: every time


Steps to Reproduce on x86_64 (64-bit):
1. yum install wine
2. wine Notepad  ## starts some background processes
3. File > Exit   ## terminate first Notepad
4. strace -v -f -o strace.out -e trace=execve wine Notepad
5. File > Exit   ## terminate second Notepad
 
Actual results: File strace.out contains the strings for the first execve, but just the addresses for most of the other execve.  Example:
----- first execve
2290  execve("/usr/bin/wine", ["wine", "Notepad"], ["ORBIT_SOCKETDIR=/tmp/orbit-jreis"..., "HOSTNAME=f12a64.local", "IMSETTINGS_INTEGRATE_DESKTOP=yes"..., {{snip}}
-----

----- second execve
2290  execve("/usr/bin/../lib/../bin/wine-preloader", ["/usr/bin/../lib/../bin/wine-prel"..., "/usr/bin/../lib/../bin/wine", 0xfffffffffff9a5f6], [0xfffffffffff9a5fe, 0xfffffffffff9a621, 0xfffffffffff9a637, {{snip}}
-----


Expected results: Arguments and environment variables to execve are printed as strings in every case.


Additional info:
Comment 1 Dmitry V. Levin 2009-09-18 19:59:11 EDT
Fixed in upstream git, see http://strace.git.sourceforge.net/git/gitweb.cgi?p=strace/strace;h=v4.5.18-102-g99c8569
Comment 2 Fedora Update System 2009-10-21 14:09:02 EDT
strace-4.5.19-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/strace-4.5.19-1.fc10
Comment 3 Fedora Update System 2009-10-21 14:09:47 EDT
strace-4.5.19-1.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/strace-4.5.19-1.fc11
Comment 4 Fedora Update System 2009-10-27 02:32:51 EDT
strace-4.5.19-1.fc10 has been pushed to the Fedora 10 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update strace'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F10/FEDORA-2009-10733
Comment 5 Fedora Update System 2009-10-27 03:13:38 EDT
strace-4.5.19-1.fc11 has been pushed to the Fedora 11 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update strace'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F11/FEDORA-2009-10843
Comment 6 Fedora Update System 2009-11-12 21:32:45 EST
strace-4.5.19-1.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Fedora Update System 2009-11-12 21:34:09 EST
strace-4.5.19-1.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.